package com.realnet.stopwatch.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.stopwatch.Entity.Stopwatch;
import com.realnet.stopwatch.Services.StopwatchService ;


@RequestMapping(value = "/Stopwatch")
 @CrossOrigin("*") 
@RestController
public class StopwatchController {
	@Autowired
	private StopwatchService Service;

@Value("${projectPath}")
	private String projectPath;
 


	@PostMapping("/Stopwatch")
		  public Stopwatch Savedata(@RequestBody Stopwatch data) {
		Stopwatch save = Service.Savedata(data)	;

		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Stopwatch/{id}")
	public  Stopwatch update(@RequestBody Stopwatch data,@PathVariable Integer id ) {
		Stopwatch update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Stopwatch/getall/page")
	public Page<Stopwatch> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Stopwatch> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Stopwatch")
	public List<Stopwatch> getdetails() {
		 List<Stopwatch> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Stopwatch")
	public List<Stopwatch> getallwioutsec() {
		 List<Stopwatch> get = Service.getdetails();		
		return get;
}
@GetMapping("/Stopwatch/{id}")
	public  Stopwatch  getdetailsbyId(@PathVariable Integer id ) {
		Stopwatch  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Stopwatch/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}



}